Doomsday Engine - Feature #1647

Replace FS1 with FS2-based resource management
2013-10-31 22:26 - skyjake

Status: Progressed Start date: 2013-10-31
Priority: High % Done: 30%
Assignee: skyjake

Category: Redesign

Target version: Architecture

Description

FS1 acts as an extension layer over the native file system, allowing one to look up resources and locate other needed native files.
FS1 is platform-dependent.

In contrast, FS2 in libdeng?2 is a virtual file system that completely hides the native file system. It is completely platform-independent.
File objects can represent any kind of data in addition to basic native files (ZIP archives, remote data over the network, dynamically
generated information, etc.).

At the moment FS1 is deprecated and it should be removed in favor of FS2 based resource management. Note that unlike FS1,
FS2's purpose extends beyond resource management.

In practice, resource management done on FS2 should be package-oriented and lookups should occur via fast in-memory indices.
Open questions:

* How to ensure old resource packs can be used as-is? Compatibility mode?

Related issues:

Related to Bug #1038: [Unix] Locating resource files (wad/pk3) Closed 2012-05-11
Related to Feature #1601: Package management In Progress  2014-04-18
Related to Feature #1216: Using alternative resources alongside the originals Rejected 2003-06-30
Related to Feature #1755: Use FS2 for runtime files Closed 2014-04-18
Related to Feature #1756: URIs for locating/identifying resources and assets Rejected 2014-04-18
Related to Feature #2192: Procedural images generated based on a text file (.... New 2017-01-10
Related to Feature #7: Next-gen renderer (codename "Gloom") Progressed 2003-07-10
History

#1 - 2015-05-29 09:01 - skyjake
- Status changed from New to In Progress

- % Done changed from 0 to 10

Marking this in progress because the basic functionality for FS2 based resource management is being built to support the new 3D model renderer:
.pack packages and assets with extremely close ties to both FS2 and Doomsday Script.

#2 - 2016-07-05 23:27 - skyjake
- % Done changed from 10 to 30

The DataBundle class now exists to interpret legacy data files into Doomsday 2 (runtime) packages.

#3 - 2016-07-06 09:19 - skyjake

- Assignee changed from Deng Team to skyjake

#4 - 2016-07-22 09:11 - skyjake

- Status changed from In Progress to Progressed

This should now be good enough for 2.0, work can continue at a later time.

#5 - 2017-01-10 12:56 - skyjake
- Related to Feature #2192: Procedural images generated based on a text file (.deimage) added

#6 - 2019-11-29 16:34 - skyjake
As work with version 3 continues, | expect the FS1 based code to be eventually retired.

#7 - 2019-11-29 16:34 - skyjake

- Related to Feature #7: Next-gen renderer (codename "Gloom") added

#8 - 2019-11-29 21:33 - skyjake

- Target version set to Architecture
